using Styx;
using System;
using Styx.Helpers;
using Styx.Pathing;
using System.Threading;
using System.Diagnostics;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Collections.Generic;
using System.IO;
using System.Runtime.InteropServices;
using Styx.Common;
using Styx.Plugins;
using System.Linq;
using System.Windows.Media;
using System.Windows.Forms;
using Styx.CommonBot.POI; 
using Bots.ArchaeologyBuddy;
using System.Text.RegularExpressions;
using System.Drawing;
using Styx.CommonBot;
using GreyMagic;
using Styx.Common.Helpers;
using Styx.CommonBot.Inventory;
using Styx.Localization;
using System.Media;
using System.Xml.Linq;
using System.Xml;
using System.Net;
using System.Globalization;
using Styx.CommonBot.Frames;
using Styx.WoWInternals.DBC;
using Styx.CommonBot.Profiles;


namespace LootARangPlugin

{

	public class Main : HBPlugin

    {
        
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public override string Author { get { return "Banzai!"; }}
        public override string Name { get { return "Loot A Rang"; }}
		public override Version Version { get { return new Version(0,0,1); }}
	    public int Corpse_Limit = 1; //3;  //Corpse number can edit
		public WoWUnit unit;


        public override void Pulse() 
        {
		  
		    if (LootableCorpses.Count() >= Corpse_Limit && !Me.Combat )
		     {
             //Logging.Write(Colors.Red, "[LAR] Lootable corpse found. Going to loot.");
			 goLoot();
		     }

        }
	
	        public WoWItem GetBoomerang()
        {
            WoWItem findlesRang = Me.BagItems.FirstOrDefault(h => h.Entry == 109167);
            if(findlesRang != null)
            {
                return findlesRang;
            }
            WoWItem lootarang = Me.BagItems.FirstOrDefault(h => h.Entry == 60854);
            if (lootarang != null)
            {
                return lootarang;
            }            
            Logging.Write(Colors.Red, "Could not find a loot-a-rang in your inventory");
            return null;
        }
	
				public void goLoot()
				  { 
					WoWItem boomerangItem = GetBoomerang();
					boomerangItem.UseContainerItem();
				  }
  

      public WoWUnit ContinueFightUnit
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(a => (!a.IsDead && !a.TaggedByOther && a.CanSelect && !a.IsFriendly && !a.IsNonCombatPet && !a.IsCritter)).OrderBy(a => a.Distance).FirstOrDefault();
            }
		}  

	  
      public WoWUnit Lootable
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(a => a!= null && a.IsDead && a.Lootable).OrderBy(a => a.Distance).FirstOrDefault();
            }
		}
		
		
	   private IOrderedEnumerable<WoWUnit> LootableCorpses
        {
            get
            {
                var lootList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(b => b.Lootable && b.Distance <= 39).OrderBy(l => l.Distance);
                return lootList;
            }
        }
	
	
  }
}		